@echo off

set FBC=fbc.exe

set FB_LIBNAME=mudgui
set FB_LIBFILE=lib%FB_LIBNAME%.a

set FB_INCDIR=inc
set FB_SRCDIR=src
set FB_BINDIR=lib\win32
set FB_EXDIR=examples

set FBC_CFLAGS=-c -w pedantic -i %FB_INCDIR%
set FBC_LFLAGS=-lib -x %FB_BINDIR%\%FB_LIBNAME%

if "%1"=="lib" goto lib:
if "%1"=="examples" goto examples:
if "%1"=="clean" goto clean:
if "%1"=="clean-examples" goto clean_examples:
if "%1"=="usage" goto usage:
goto usage:

:lib
	echo on
	
	:: compile source files
	@for /R %%s in (%FB_SRCDIR%\*.bas) do %FBC% %FBC_CFLAGS% "%%s"
	
	:: link object files
	%FBC% %FBC_LFLAGS% %FB_SRCDIR%\*.o
	
	@goto end:

:examples
	echo on
	@if not exist %FB_BINDIR%\%FB_LIBFILE% goto lib:
	@for /R %FB_EXDIR% %%s in (*.bas) do %FBC% -i %FB_INCDIR% -p %FB_BINDIR% -l %FB_LIBNAME% "%%s"
	@goto end:

:clean
	echo on
	del /Q "%FB_BINDIR%\%FB_LIBFILE%"  2> NUL
	del /Q "%FB_SRCDIR%\*.o" 2> NUL
	@goto end:

:clean_examples
	echo on
	del /Q /S "%FB_EXDIR%\*.exe"  2> NUL
	@goto end:

:usage
	@echo off
	echo "usage: BUILD.BAT [lib|examples|clean|clean-examples]"
	echo.
	echo    Running BUILD.BAT with no commandline arguments displays this help
	echo    text. One of the following options can be specified:
	echo.
	echo    lib              - builds the %FB_LIBNAME% static library. the
	echo                       library will be placed in %FB_BINDIR%.
	echo    examples         - builds the example programs, which can be found
	echo                       in %FB_EXDIR%. if the the %FB_LIBNAME%
	echo                       static library has not been built, it will be.
	echo    clean            - removes the %FB_LIBNAME% static library.
	echo    clean-examples   - removes the examples programs.
	echo.

:end
